## wxHtmlWindow

wxHtmlWindow is probably the only class you will directly use unless you want to do something special (like adding new tag handlers or MIME filters).

The purpose of this class is to display HTML pages (either local file or downloaded via HTTP protocol) in a window. The width of the window is constant - given in the constructor - and virtual height is changed dynamically depending on page size. Once the window is created you can set its content by calling SetPage(text), LoadPage(filename) or LoadFile.

Note

wxHtmlWindow uses the wxImage class for displaying images. Don't forget to initialize all image formats you need before loading any page! (See wxInitAllImageHandlers and wxImage::AddHandler.)

Derived from

wxScrolledWindow

Include files

<wx/html/htmlwin.h>

Window styles

wxHW_SCROLLBAR_NEVER | Never display scrollbars, not even when the page is larger than the window.
wxHW_SCROLLBAR_AUTO | Display scrollbars only if page's size exceeds window's size.
wxHW_NO_SELECTION | Don't allow the user to select text.

Event handling

To process input from a wxHtmlWindow, use these event handler macros to direct input to member functions that take a wxHtmlCellEvent argument or a wxHtmlLinkEvent.

EVT_HTML_CELL_CLICKED(id, func) | A wxHtmlCell was clicked.
EVT_HTML_CELL_HOVER(id, func) | The mouse passed over a wxHtmlCell.
EVT_HTML_LINK_CLICKED(id, func) | A wxHtmlCell which contains an hyperlink was clicked.

See also

wxHtmlLinkEvent, wxHtmlCellEvent

wxHtmlWindow::wxHtmlWindow
wxHtmlWindow::AddFilter
wxHtmlWindow::AppendToPage
wxHtmlWindow::GetInternalRepresentation
wxHtmlWindow::GetOpenedAnchor
wxHtmlWindow::GetOpenedPage
wxHtmlWindow::GetOpenedPageTitle
wxHtmlWindow::GetRelatedFrame
wxHtmlWindow::HistoryBack
wxHtmlWindow::HistoryCanBack
wxHtmlWindow::HistoryCanForward
wxHtmlWindow::HistoryClear
wxHtmlWindow::HistoryForward
wxHtmlWindow::LoadFile
wxHtmlWindow::LoadPage
wxHtmlWindow::OnCellClicked
wxHtmlWindow::OnCellMouseHover
wxHtmlWindow::OnLinkClicked
wxHtmlWindow::OnOpeningURL
wxHtmlWindow::OnSetTitle
wxHtmlWindow::ReadCustomization
wxHtmlWindow::SelectAll
wxHtmlWindow::SelectionToText
wxHtmlWindow::SelectLine
wxHtmlWindow::SelectWord
wxHtmlWindow::SetBorders
wxHtmlWindow::SetFonts
wxHtmlWindow::SetPage
wxHtmlWindow::SetRelatedFrame
wxHtmlWindow::SetRelatedStatusBar
wxHtmlWindow::ToText
wxHtmlWindow::WriteCustomization

### wxHtmlWindow::wxHtmlWindow

wxHtmlWindow()

Default constructor.

wxHtmlWindow(wxWindow *parent, wxWindowID id = -1, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxHW_DEFAULT_STYLE, const wxString& name = "htmlWindow")

Constructor. The parameters are the same as for the wxScrolledWindow constructor.

Parameters

style

Window style. See wxHtmlWindow.

### wxHtmlWindow::AddFilter

static void AddFilter(wxHtmlFilter *filter)

Adds input filter to the static list of available filters. These filters are present by default:

- `text/html` MIME type
- `image/*` MIME types
- Plain Text filter (this filter is used if no other filter matches)

### wxHtmlWindow::AppendToPage

bool AppendToPage(const wxString& source)

Appends HTML fragment to currently displayed text and refreshes the window.

Parameters

source

HTML code fragment

Return value

false if an error occurred, true otherwise.

### wxHtmlWindow::GetInternalRepresentation

wxHtmlContainerCell* GetInternalRepresentation() const

Returns pointer to the top-level container.

See also: Cells Overview, Printing Overview

### wxHtmlWindow::GetOpenedAnchor

wxString GetOpenedAnchor()

Returns anchor within currently opened page (see GetOpenedPage). If no page is opened or if the displayed page wasn't produced by call to LoadPage, empty string is returned.

### wxHtmlWindow::GetOpenedPage

wxString GetOpenedPage()

Returns full location of the opened page. If no page is opened or if the displayed page wasn't produced by call to LoadPage, empty string is returned.

### wxHtmlWindow::GetOpenedPageTitle

wxString GetOpenedPageTitle()

Returns title of the opened page or wxEmptyString if current page does not contain `<TITLE>` tag.

### wxHtmlWindow::GetRelatedFrame

wxFrame* GetRelatedFrame() const

Returns the related frame.

### wxHtmlWindow::HistoryBack

bool HistoryBack()

Moves back to the previous page. (each page displayed using LoadPage is stored in history list.)

### wxHtmlWindow::HistoryCanBack

bool HistoryCanBack()

Returns true if it is possible to go back in the history (i.e. HistoryBack() won't fail).

### wxHtmlWindow::HistoryCanForward

bool HistoryCanForward()

Returns true if it is possible to go forward in the history (i.e. HistoryBack() won't fail).

### wxHtmlWindow::HistoryClear

void HistoryClear()

Clears history.

### wxHtmlWindow::HistoryForward

bool HistoryForward()

Moves to next page in history.

### wxHtmlWindow::LoadFile

virtual bool LoadFile(const wxFileName& filename)

Loads HTML page from file and displays it.

Return value

false if an error occurred, true otherwise

See also

LoadPage

### wxHtmlWindow::LoadPage

virtual bool LoadPage(const wxString& location)

Unlike SetPage this function first loads HTML page from location and then displays it. See example:

    htmlwin->LoadPage("help/myproject/index.htm");

Parameters

location

The address of document. See wxFileSystem for details on address format and behaviour of "opener".

Return value

false if an error occurred, true otherwise

See also

LoadFile

### wxHtmlWindow::OnCellClicked

virtual bool OnCellClicked(wxHtmlCell *cell, wxCoord x, wxCoord y, const wxMouseEvent& event)

This method is called when a mouse button is clicked inside wxHtmlWindow.

The default behaviour is to emit a wxHtmlCellEvent and, if the event was not processed or skipped, call OnLinkClicked if the cell contains an hypertext link.

Overloading this method is deprecated; intercept the event instead.

Parameters

cell

The cell inside which the mouse was clicked, always a simple (i.e. non-container) cell

x, y

The logical coordinates of the click point

event

The mouse event containing other information about the click

Return value

`true` if a link was clicked, `false` otherwise.

### wxHtmlWindow::OnCellMouseHover

virtual void OnCellMouseHover(wxHtmlCell *cell, wxCoord x, wxCoord y)

This method is called when a mouse moves over an HTML cell. Default behaviour is to emit a wxHtmlCellEvent. Overloading this method is deprecated; intercept the event instead.

Parameters

cell

The cell inside which the mouse is currently, always a simple (i.e. non-container) cell

x, y

The logical coordinates of the click point

### wxHtmlWindow::OnLinkClicked

virtual void OnLinkClicked(const wxHtmlLinkInfo& link)

Called when user clicks on hypertext link. Default behaviour is to emit a wxHtmlLinkEvent and, if the event was not processed or skipped, call LoadPage and do nothing else. Overloading this method is deprecated; intercept the event instead.

Also see wxHtmlLinkInfo.

### wxHtmlWindow::OnOpeningURL

virtual wxHtmlOpeningStatus OnOpeningURL(wxHtmlURLType type,const wxString& url, wxString *redirect)

Called when an URL is being opened (either when the user clicks on a link or an image is loaded). The URL will be opened only if OnOpeningURL returns `wxHTML_OPEN`. This method is called by wxHtmlParser::OpenURL. You can override OnOpeningURL to selectively block some URLs (e.g. for security reasons) or to redirect them elsewhere. Default behaviour is to always return `wxHTML_OPEN`.

Parameters

type

Indicates type of the resource. Is one of

wxHTML_URL_PAGE | Opening a HTML page.
wxHTML_URL_IMAGE | Opening an image.
wxHTML_URL_OTHER | Opening a resource that doesn't fall into any other category.

url

URL being opened.

redirect

Pointer to wxString variable that must be filled with an URL if OnOpeningURL returns `wxHTML_REDIRECT`.

Return value

wxHTML_OPEN | Open the URL.
wxHTML_BLOCK | Deny access to the URL, wxHtmlParser::OpenURL will return NULL.
wxHTML_REDIRECT | Don't open url, redirect to another URL. OnOpeningURL must fill *redirect with the new URL. OnOpeningURL will be called again on returned URL.

### wxHtmlWindow::OnSetTitle

virtual void OnSetTitle(const wxString& title)

Called on parsing `<TITLE>` tag.

### wxHtmlWindow::ReadCustomization

virtual void ReadCustomization(wxConfigBase *cfg, wxString path = wxEmptyString)

This reads custom settings from wxConfig. It uses the path 'path' if given, otherwise it saves info into currently selected path. The values are stored in sub-path `wxHtmlWindow`

Read values: all things set by SetFonts, SetBorders.

Parameters

cfg

wxConfig from which you want to read the configuration.

path

Optional path in config tree. If not given current path is used.

### wxHtmlWindow::SelectAll

void SelectAll()

Selects all text in the window.

See also

SelectLine, SelectWord

### wxHtmlWindow::SelectionToText

wxString SelectionToText()

Returns current selection as plain text. Returns empty string if no text is currently selected.

### wxHtmlWindow::SelectLine

void SelectLine(const wxPoint& pos)

Selects the line of text that pos points at. Note that pos is relative to the top of displayed page, not to window's origin, use CalcUnscrolledPosition to convert physical coordinate.

See also

SelectAll, SelectWord

### wxHtmlWindow::SelectWord

void SelectWord(const wxPoint& pos)

Selects the word at position pos. Note that pos is relative to the top of displayed page, not to window's origin, use CalcUnscrolledPosition to convert physical coordinate.

See also

SelectAll, SelectLine

### wxHtmlWindow::SetBorders

void SetBorders(int b)

This function sets the space between border of window and HTML contents. See image:

Parameters

b

indentation from borders in pixels

### wxHtmlWindow::SetFonts

void SetFonts(const wxString& normal_face, const wxString& fixed_face, const int *sizes = NULL)

This function sets font sizes and faces.

Parameters

normal_face

This is face name for normal (i.e. non-fixed) font. It can be either empty string (then the default face is chosen) or platform-specific face name. Examples are "helvetica" under Unix or "Times New Roman" under Windows.

fixed_face

The same thing for fixed face ( <TT>..</TT> )

sizes

This is an array of 7 items of int type. The values represent size of font with HTML size from -2 to +4 ( <FONT SIZE=-2> to <FONT SIZE=+4> ). Default sizes are used if sizes is NULL.

Defaults

Default font sizes are defined by constants wxHTML_FONT_SIZE_1, wxHTML_FONT_SIZE_2, ..., wxHTML_FONT_SIZE_7. Note that they differ among platforms. Default face names are empty strings.

### wxHtmlWindow::SetPage

bool SetPage(const wxString& source)

Sets HTML page and display it. This won't load the page!! It will display the source. See example:

    htmlwin -> SetPage("<html><body>Hello, world!</body></html>");

If you want to load a document from some location use LoadPage instead.

Parameters

source

The HTML document source to be displayed.

Return value

false if an error occurred, true otherwise.

### wxHtmlWindow::SetRelatedFrame

void SetRelatedFrame(wxFrame* frame, const wxString& format)

Sets the frame in which page title will be displayed. format is format of frame title, e.g. "HtmlHelp : %s". It must contain exactly one %s. This %s is substituted with HTML page title.

### wxHtmlWindow::SetRelatedStatusBar

void SetRelatedStatusBar(int bar)

After calling SetRelatedFrame, this sets statusbar slot where messages will be displayed. (Default is -1 = no messages.)

Parameters

bar

statusbar slot number (0..n)

### wxHtmlWindow::ToText

wxString ToText()

Returns content of currently displayed page as plain text.

### wxHtmlWindow::WriteCustomization

virtual void WriteCustomization(wxConfigBase *cfg, wxString path = wxEmptyString)

Saves custom settings into wxConfig. It uses the path 'path' if given, otherwise it saves info into currently selected path. Regardless of whether the path is given or not, the function creates sub-path `wxHtmlWindow`.

Saved values: all things set by SetFonts, SetBorders.

Parameters

cfg

wxConfig to which you want to save the configuration.

path

Optional path in config tree. If not given, the current path is used.